import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

public class KrydsOgBolle extends JApplet implements MouseListener  {
  static int rs[]={0,0};
  static int[][] felt={{0,0,0},{0,0,0},{0,0,0}};
  static int[] feltVaerdi={0,0,0,0,0,0,0,0,0};
  static int[] tsum={0,0,0,0,0,0,0,0};
  static int[] x1Button = {10,110};
  static int[] y1Button = {40,40};
  static int[] buttonWidth = {90,80};
  static int[] buttonHeight = {30,30};
  static String[] caption = {"Computer","Spiller"};

  static String kryds="X", bolle="O";
  static boolean stop=false, computer=false, start=false;
  static int traek=0,feltNo;
  static int width,height;
  static int brikWidth, brikHeight;
  static int fontSize = brikHeight/3;
  static int offsetY=75;
  static String gammelDialog="";

  static final int SOEJLER = 3;
  static final int RAEKKER = 3;
  static final int XDIALOG=10;
  static final int YDIALOG=30;

  Graphics graphics;


  public void init() {

    width=getBounds().width;
    height=getBounds().height;
    brikWidth= width /SOEJLER;
    brikHeight = (height-offsetY)/RAEKKER;
    getContentPane().addMouseListener(this);
  }

  public void paint(Graphics graphics) {
    this.graphics = graphics;
    skrivDialog("Vlg, hvem der skal begynde");
    graphics.setColor(Color.gray);
    graphics.setFont(new Font("Serif", Font.BOLD, 10));
    for (int k=0;k<2;k++)
      tegnButton(x1Button[k],y1Button[k],buttonWidth[k],buttonHeight[k],caption[k]);
    graphics.setFont(new Font("Serif", Font.BOLD, fontSize));
    graphics.setColor(Color.blue);
    tegnBrikker();
    graphics.setColor(Color.white);
  }

  private void delay(int ms) {
    try {
      Thread.sleep(ms);
    }
    catch (Exception ignored) {
    }
  }

  private int[] findFeltPaaLinie(int vaerdi, int linie ) {
    int[] rs={1,1};
    if (linie<3) {
      for (int k=0;k<3;k++) {
        if (felt[linie][k]==vaerdi) {
          rs[0]=linie; rs[1]=k;
        }
      }
    }
    else
    if (linie<6) {
      for (int k=0;k<3;k++) {
        if (felt[k][linie-3]==vaerdi) {
          rs[0]=k; rs[1]=linie-3;
        }
      }
    }
    else
    if(linie==6) {
      for (int k=0;k<3;k++) {
        if (felt[k][k]==vaerdi) {
          rs[0]=k; rs[1]=k;
        }
      }
    }
    else {
      for (int k=0;k<3;k++) {
        if (felt[2-k][k]==vaerdi) {
          rs[0]=2-k; rs[1]=k;
        }
      }
    }
    return rs;
  }

  private int tvaersum(int linie) {
    int sum=0;
    if (linie<3)
      for (int k=0;k<3;k++) sum=sum+felt[linie][k];
    else
    if (linie<6)
      for (int k=0;k<3;k++) sum=sum+felt[k][linie-3];
    else
    if(linie==6)
      for (int k=0;k<3;k++) sum=sum+felt[k][k];
    else
      for (int k=0;k<3;k++) sum=sum+felt[k][2-k];
    return sum;
  }

  private void lavTvaersummer() {
    for (int k=0;k<8;k++) tsum[k]=tvaersum(k);
  }

  private int[] feltNoTilRaekSojl(int feltNo) {
    int[] rs={0,0};
    rs[0]=feltNo/3; rs[1]=feltNo%3;
    return rs;
  }

  private int raekSojlTilFeltNo(int[] rs) {
    return rs[0]*SOEJLER + rs[1];
  }

  private int vaelgLedigtFelt() {
    int feltNo=0;
    if (traek<10) {
      while (feltVaerdi[feltNo]!=0) feltNo++;
    }
    return feltNo;
  }

  private void udfyldFelt(String kryds,int[] rs) {
    graphics=this.getGraphics();
    fontSize=2*brikHeight/3;
    graphics.setFont(new Font("Serif", Font.BOLD, fontSize));
    graphics.setColor(Color.white);
    int x1=rs[1]*brikWidth;
    int y1=rs[0]*brikHeight+offsetY;
    graphics.drawString(kryds,x1+20,y1+4*brikHeight/5);
  }

  private boolean spilVundet(int sum) {
    if (traek>4) {
      for (int k=0;k<8; k++)
        if (tsum[k]==sum) return true;
    }
    return false;
  }

  private void computerTraek() {
    int linie=0;
    boolean spillefelt=false;
    if (computer && !stop) {
      for (int k=0; k<8; k++) {
        if (tsum[k]==2) {
          spillefelt=true;
          linie=k;
        }
      }
      if (spillefelt)
        rs=findFeltPaaLinie(0,linie);
      else {
        for (int k=0; k<8; k++) {
          if (tsum[k]==20) {
            spillefelt=true;
            linie=k;
          }
        }
        if (spillefelt)
          rs=findFeltPaaLinie(0,linie);
        else {
          for (int k=0; k<8; k++) {
            if (tsum[k]==1) {
              spillefelt=true;
              linie=k;
            }
          }
          if (spillefelt)
            rs=findFeltPaaLinie(0,linie);
          else
            if ((feltVaerdi[4]==0) && (int)(Math.random()*2)==0)
              rs=feltNoTilRaekSojl(4);
            else
              rs=feltNoTilRaekSojl(vaelgLedigtFelt());
        }
      }
      felt[rs[0]][rs[1]]=1;
      udfyldFelt(kryds,rs);
      feltVaerdi[raekSojlTilFeltNo(rs)]=1;
      lavTvaersummer();
      traek++;
      computer=false;
    }
  }

  private void tegnBrikker() {
    for (int r=0; r<RAEKKER; r++) {
      for (int s=0; s<SOEJLER; s++) {
        tegnBrik(r,s);
      }
    }
  }

  private void skrivDialog(String dialog) {
    graphics=this.getGraphics();
    graphics.setFont(new Font("Serif", Font.BOLD, 12));
    graphics.setColor(Color.white);
    graphics.drawString(gammelDialog,XDIALOG,YDIALOG);
    gammelDialog=dialog;
    graphics.setColor(Color.black);
    graphics.drawString(dialog,XDIALOG,YDIALOG);
  }

  private void tegnButton(int x1, int y1, int bw, int bh, String cap) {
    graphics=this.getGraphics();
    graphics.setColor(Color.lightGray);
    graphics.fillRect(x1,y1,bw-1,bh-1);
    graphics.setColor(Color.gray);
    graphics.drawRect(x1,y1,bw-1,bh-1);
    graphics.setColor(Color.white);
    graphics.drawRect(x1+1,y1+1,bw-3,bh-3);
    graphics.setColor(Color.gray);
    graphics.drawRect(x1+2,y1+2,bw-5,bh-5);
    fontSize=2*bh/5;
    graphics.setFont(new Font("Serif", Font.BOLD, fontSize));
    int lenCap=cap.length();
    int pixSizeChar=3*fontSize/4;
    int pixLenCap=lenCap*pixSizeChar;
    int delX=(bw-pixLenCap)/2;
    if (delX<0) delX=5;
    graphics.setColor(Color.black);
    graphics.drawString(cap,x1+delX,y1+2*bh/3);
  }

  private void tegnBrik(int r, int s) {

    int x1 = s*brikWidth;
    int y1 = r*brikHeight+offsetY;

    graphics.setColor(Color.blue);
    graphics.fillRect(x1,y1,brikWidth-1,brikHeight-1);
    graphics.setColor(Color.gray);
    graphics.drawRect(x1,y1,brikWidth-1,brikHeight-1);
    graphics.setColor(Color.white);
    graphics.drawRect(x1+1,y1+1,brikWidth-3,brikHeight-3);
    graphics.setColor(Color.gray);
    graphics.drawRect(x1+2,y1+2,brikWidth-5,brikHeight-5);
  }

  private int pixelTilSoejle(int x) {
    float floatx=(float)x;
    float floatbrikWidth=(float)brikWidth;
    return (int)(floatx/floatbrikWidth);
  }

  private int pixelTilRaekke(int y) {
    float floaty=(float)(y-offsetY);
    float floatbrikHeight=(float)brikHeight;
    return (int)(floaty/floatbrikHeight);
  }

  private boolean museklikIRektangel(int xMouse, int yMouse, int x1, int y1, int rekWidth, int rekHeight) {
    return (x1<=xMouse) && (xMouse<=x1+rekWidth) && (y1<=yMouse) && (yMouse<=y1+rekHeight);
  }

  public void mouseClicked(MouseEvent mouseEvent) {
    int xMouse=mouseEvent.getX();
    int yMouse=mouseEvent.getY();
    if (museklikIRektangel(xMouse,yMouse,x1Button[0],y1Button[0],buttonWidth[0],buttonHeight[0])) {
      if (traek==0) {
        skrivDialog("Computeren begynder");
        start=true;
        if ((int)(Math.random()*2)==0)
          feltNo=vaelgLedigtFelt();
        else
          feltNo=4;
        feltVaerdi[feltNo]=1;
        rs=feltNoTilRaekSojl(feltNo);
        felt[rs[0]][rs[1]]=1;
        lavTvaersummer();
        delay(500);
        udfyldFelt(kryds,rs);
        traek++;
        computer=false;
      }
      else
        skrivDialog("Du kan ikke begynde forfra!!");
    }
    else
      if (museklikIRektangel(xMouse,yMouse,x1Button[1],y1Button[1],buttonWidth[1],buttonHeight[1])) {
        if (traek==0) {
          skrivDialog("Du begynder. Klik p et felt!");
          kryds="O"; bolle="X";
          start=true;
        }
        else
          skrivDialog("Du kan ikke begynde forfra!!");
      }
      else
        if (museklikIRektangel(xMouse,yMouse,3,offsetY,width-3,height-3)) {
          if (start) {
            if(!stop && !computer) {
              rs[0]=pixelTilRaekke(yMouse);
              rs[1]=pixelTilSoejle(xMouse);
              if ((rs[0]>=0) && (rs[1]>=0) && (rs[0]<RAEKKER) && (rs[1]<SOEJLER)) {
                feltNo=raekSojlTilFeltNo(rs);
                if (feltVaerdi[feltNo]==0) {
                  traek++;
                  feltVaerdi[feltNo]=10;
                  rs=feltNoTilRaekSojl(feltNo);
                  felt[rs[0]][rs[1]]=10;
                  udfyldFelt(bolle,rs);
                  lavTvaersummer();
                  computer=true;
                  delay(1000);
                  if (spilVundet(30)) {
                    stop=true;
                    skrivDialog("OK Du vandt!");
                  }
                  else
                    if (traek==9) {
                      skrivDialog("Spillet sluttede uafgjort");
                      stop=true;
                    }
                    else {
                      computerTraek();
                      if (spilVundet(3)) {
                        skrivDialog("Jeg vandt!");
                        stop=true;
                      }
                      else
                        if (traek==9) {
                          skrivDialog("Spillet sluttede uafgjort");
                          stop=true;
                        }
                        else
                          skrivDialog("Lav dit nste trk.");
                    }
                }
                else
                  skrivDialog("Dette felt er anvendt!");
              }
            }
            else
              skrivDialog("Spillet er slut du tabte");
          }
          else
            skrivDialog("Vlg spiller, fr du beynder");
      }
  }

  public void mouseEntered(MouseEvent mouseEvent) {
  }

  public void mouseExited(MouseEvent mouseEvent) {
  }

  public void mousePressed(MouseEvent mouseEvent) {
  }

  public void mouseReleased(MouseEvent mouseEvent) {
  }

}
