import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

public class MandagsChancen extends JApplet implements MouseListener  {

  static String[] beloeb ={"10.000","10.000","25.000","25.000","50.000","50.000","100.000",
                           "100.000","250.000"};
  static String[] feltNoStr={"1","2","3","4","5","6","7","8","9"};
  static boolean[] optaget={false,false,false,false,false,false,false,false,false};
  static String[] felt = new String[9];
  String feltBeloeb="00.000";
  float gevinstFelt=0,sidsteFelt=0;
  int antalForsoeg=0;
  boolean stop=false, fortsaet=false;

  Graphics graphics;

  static int width,height;
  static int brikWidth, brikHeight;
  static String gammelDialog="";
  static int[] x1Button = {50,150,250};
  static int[] y1Button = {50,50,50};
  static int[] buttonWidth = {75,75,75};
  static int[] buttonHeight = {25,25,25};
  static String[] caption = {"Start","Fortst","Stop"};

  static final int SOEJLER  = 3;
  static final int RAEKKER = 3;
  static final int BLUE=2;
  static final int WHITE=1;
  static final int XDIALOG=10;
  static final int YDIALOG=30;

  int fontSize = brikHeight/3;

  int offsetY=80;

  public void init() {
    for(int i=0; i<=8; i++) {
      int plads=(int)(9*Math.random());
      while (optaget[plads]) {
        plads=(int)(9*Math.random());
      }
      optaget[plads]=true;
      felt[i]=beloeb[plads];
    }

    width=getBounds().width;
    height=getBounds().height;
    brikWidth= width /SOEJLER;
    brikHeight = (height-offsetY)/RAEKKER;
    getContentPane().addMouseListener(this);
  }

  public void paint(Graphics graphics) {
    this.graphics = graphics;
    skrivDialog("Tryk p start. Klik herefter p et felt. Mske er du heldig!");
    graphics.setColor(Color.gray);
    graphics.setFont(new Font("Serif", Font.BOLD, 10));
    for (int k=0;k<3;k++)
      tegnButton(x1Button[k],y1Button[k],buttonWidth[k],buttonHeight[k],caption[k]);
    graphics.setFont(new Font("Serif", Font.BOLD, fontSize));
    graphics.setColor(Color.blue);
    tegnBrikker();
  }

  private void tegnBrikker() {
    for (int raekke=1; raekke <= RAEKKER; raekke++) {
      for (int soejle=1; soejle <= SOEJLER; soejle++) {
        tegnBrik(raekke,soejle,BLUE);
      }
    }
  }

  private void skrivDialog(String dialog) {
    graphics=this.getGraphics();
    graphics.setFont(new Font("Serif", Font.BOLD, 12));
    graphics.setColor(Color.white);
    graphics.drawString(gammelDialog,XDIALOG,YDIALOG);
    gammelDialog=dialog;
    graphics.setColor(Color.black);
    graphics.drawString(dialog,XDIALOG,YDIALOG);
  }

  private void tegnButton(int x1, int y1, int bw, int bh, String cap) {
    graphics=this.getGraphics();
    graphics.setColor(Color.gray);
    graphics.fillRect(x1,y1,bw-1,bh-1);
    graphics.setColor(Color.black);
    graphics.drawRect(x1,y1,bw-1,bh-1);
    graphics.setColor(Color.gray);
    graphics.drawRect(x1+1,y1+1,bw-3,bh-3);
    graphics.setColor(Color.black);
    graphics.drawRect(x1+2,y1+2,bw-5,bh-5);
    fontSize=2*bh/3;
    graphics.setFont(new Font("Serif", Font.BOLD, fontSize));
    graphics.setColor(Color.white);
    int lenCap=cap.length();
    int pixSizeChar=3*fontSize/4;
    int pixLenCap=lenCap*pixSizeChar;
    int delX=(bw-pixLenCap)/2;
    if (delX<0) delX=5;
    graphics.drawString(cap,x1+delX,y1+2*bh/3);
  }

  private void tegnBrik(int raekke, int soejle, int color) {
    graphics=this.getGraphics();
    if (color==BLUE)
      graphics.setColor(Color.blue);
    else
      graphics.setColor(Color.white);

    int x1 = (soejle-1)*brikWidth;
    int y1 = (raekke-1)*brikHeight+offsetY;

    graphics.fillRect(x1,y1,brikWidth-1,brikHeight-1);
    graphics.setColor(Color.gray);
    graphics.drawRect(x1,y1,brikWidth-1,brikHeight-1);
    graphics.setColor(Color.white);
    graphics.drawRect(x1+1,y1+1,brikWidth-3,brikHeight-3);
    graphics.setColor(Color.gray);
    graphics.drawRect(x1+2,y1+2,brikWidth-5,brikHeight-5);
    fontSize=2*brikHeight/3;
    graphics.setFont(new Font("Serif", Font.BOLD, fontSize));
    graphics.setColor(Color.white);
    int feltNo=(raekke-1)*SOEJLER+soejle;
    graphics.drawString(feltNoStr[feltNo-1],x1+40,y1+4*brikHeight/5);
  }

  private int pixelTilSoejle(int x) {
    float floatx=(float)x;
    float floatbrikWidth=(float)brikWidth;
    return (int)(floatx/floatbrikWidth)+1;
  }

  private int pixelTilRaekke(int y) {
    float floaty=(float)(y-offsetY);
    float floatbrikHeight=(float)brikHeight;
    return (int)(floaty/floatbrikHeight)+1;
  }
  private boolean museklikIRektangel(int xMouse, int yMouse, int x1, int y1, int rekWidth, int rekHeight) {
    return (x1<=xMouse) && (xMouse<=x1+rekWidth) && (y1<=yMouse) && (yMouse<=y1+rekHeight);
  }
  public void mouseClicked(MouseEvent mouseEvent) {
    int xMouse=mouseEvent.getX();
    int yMouse=mouseEvent.getY();
    if (museklikIRektangel(xMouse,yMouse,x1Button[0],y1Button[0],buttonWidth[0],buttonHeight[0])) {
      if (antalForsoeg==0) {
        fortsaet=true;
        skrivDialog("Klik p et felt. Mske er du heldig!");
      }
      else {
        skrivDialog("Du kan ikke begynde forfra!!");
        stop=true;
      }
    }
    else
      if (museklikIRektangel(xMouse,yMouse,x1Button[1],y1Button[1],buttonWidth[1],buttonHeight[1])) {
        if (antalForsoeg==3) {
            skrivDialog("Spillet er afsluttet! Du har kun 3 forsg");
            stop=true;
        }
        else
          if(stop)
            skrivDialog("Du kan ikke afdkke flere felter, nr du har stoppet");
          else {
            fortsaet=true;
            skrivDialog("Klik p et nyt felt. Mske er du heldig");
          }
      }
      else
        if (museklikIRektangel(xMouse,yMouse,x1Button[2],y1Button[2],buttonWidth[2],buttonHeight[2])) {
          skrivDialog("Spillet er afsluttet! Du vandt "+feltBeloeb+" kr.");
          stop=true;
        }
        else
          if (museklikIRektangel(xMouse,yMouse,3,offsetY,width-3,height-3)) {
            int raekke=pixelTilRaekke(yMouse);
            int soejle=pixelTilSoejle(xMouse);
            if (stop)
              skrivDialog("Du kan ikke afdkke flere felter, nr du har stoppet");
            else
            if (fortsaet) {
              if ((raekke>0) && (soejle>0) && (raekke<=RAEKKER) && (soejle<=SOEJLER)) {
                int feltNo=(raekke-1)*SOEJLER+soejle;
                if (optaget[feltNo]) {
                  optaget[feltNo]=false;
                  fortsaet=false;
                  antalForsoeg++;
                  sidsteFelt=gevinstFelt;
                  feltBeloeb=felt[feltNo-1];
                  gevinstFelt=Float.parseFloat(felt[feltNo-1]);
                  graphics=this.getGraphics();
                  tegnBrik(raekke,soejle,WHITE);
                  graphics.setColor(Color.red);
                  fontSize = brikHeight/4;
                  graphics.setFont(new Font("Serif", Font.BOLD, fontSize));
                  int x1=(soejle-1)*brikWidth;
                  int y1=(raekke-1)*brikHeight;
                  graphics.drawString(felt[feltNo-1],x1+10,y1+5*fontSize/2+offsetY);
                  if (gevinstFelt<sidsteFelt) {
                    skrivDialog("Spillet er afsluttet! Du satsede forkert og har mistet alt");
                    feltBeloeb="0";
                    stop=true;
                  }
                  else {
                    if (antalForsoeg==3) {
                      skrivDialog("Spillet er afsluttet! Du vandt "+felt[feltNo-1]+" kr.");
                      stop=true;
                    }
                    else {
                      int antalForsoegTilbage=3-antalForsoeg;
                      skrivDialog("Du har "+antalForsoegTilbage+
                                          " chancer tilbage. Tryk Fortst for at fortstte");
                    }
                  }
                }
                else skrivDialog("Du kan ikke afdkke samme felt to gange!");
              }
            }
            else
              skrivDialog("Tryk Fortst-knappen, fr du klikker p et felt!");
         }
  }

  public void mouseEntered(MouseEvent mouseEvent) {
  }

  public void mouseExited(MouseEvent mouseEvent) {
  }

  public void mousePressed(MouseEvent mouseEvent) {
  }

  public void mouseReleased(MouseEvent mouseEvent) {
  }

}
