import javax.swing.*;
import javax.swing.event.*;
import java.awt.event.*;
import java.util.*;
import MyClasses.*;

public class RapportMenuListener implements ActionListener {

  private static Vector boeger, laanere, udlaante;
  private String titel, isbn, forfatter, laanerId, navn, adresse;
  private Printer prn;

  public void udskrivBogListe(Vector boeger) {

    prn = new Printer();
    prn.println();
    prn.println("Liste over bger i Biblioteket");
    prn.println();

    for (int i=0; i<boeger.size();i++) {
      Bog bog=(Bog) boeger.get(i);
      prn.println();
      prn.println("ISBN: "+bog.isbn);
      prn.println("Forfatter: "+bog.forfatter);
      prn.println("Titel: "+bog.titel);
      prn.println("DecimalKlasse: "+bog.decklasse);
      prn.println("Antal: "+bog.antal);
      prn.println("Registreringsdato: "+bog.reg_dato);
      prn.println("Annotation: "+bog.annotation);
      prn.println();
    }
    prn.close();
  }

  public void udskrivLaanereAfBog(String titel, String forfatter, Vector laanere) {

    prn = new Printer();
    prn.println();
    prn.println("Bogen "+titel+" af "+forfatter);
    prn.println("Er udlnt til flgende lnere:");
    prn.println();
    for (int i=0; i<laanere.size();i++) {
      Laaner laaner=(Laaner) laanere.get(i);
      prn.println("Navn: "+laaner.navn);
      prn.println("Adrese: "+laaner.adresse);
      prn.println();
    }
    prn.close();
  }

  public void udskrivBoegerSomLaanerHar(String navn, String adresse, Vector boeger) {

    prn = new Printer();
    prn.println();
    prn.println("Lner: "+navn);
    prn.println("Adresse: "+adresse);
    if (boeger.size()>0) {
      prn.println("Har lnt flgende bger:");
      prn.println();
      for (int i=0; i<boeger.size();i++) {
        Bog bog=(Bog) boeger.get(i);
        prn.println();
        prn.println("Forfatter: "+bog.forfatter);
        prn.println("Titel: "+bog.titel);
        prn.println();
      }
    }
    else {
      prn.println("Har ingen udlnte bger:");
    }
    prn.close();
  }

  public void hjemkaldBogFraLaaner(Bog bog, Laaner laaner, long dage) {

    prn = new Printer();
    prn.println();
    prn.println("Hjemkaldelse af bog");
    prn.println(laaner.navn);
    prn.println(laaner.adresse);
    prn.println("Har lnt bogen:"+bog.titel+" af "+bog.forfatter);
    dage = dage-30;
    prn.println("Afleveringsfristen er overskredet med "+dage+" dage");
    prn.println("Bogen bedes returneret snarest");
    prn.println("Med Venlig Hilsen");
    prn.println("Biblioteket");
    prn.println();

    prn.close();
  }

  public void actionPerformed(ActionEvent actionEvent) {
    String action = actionEvent.getActionCommand();

    if (action.equals("Bogliste")) {
      boeger=DbBog.selectAllWhere("");
      udskrivBogListe(boeger);
    }
    else
      if (action.equals("Lnere af Bog")) {
        Vector laanere = new Vector();
        Dialogs.showMessage("Lnere af Bog");
        isbn=Boeger.isbnTextField.getText().trim();
        titel=Boeger.titelTextField.getText().trim();
        forfatter=Boeger.forfatterTextField.getText().trim();
        udlaante=DbUdlaan.selectAllWhere("ISBN = '"+isbn+"'");
        for (int i=0; i<udlaante.size(); i++) {
          Udlaan udlaan=(Udlaan) udlaante.get(i);
          Laaner laaner= (Laaner) DbLaaner.selectAllWhere("LAANER_ID = '"+udlaan.laaner_Id+"'").get(0);
          laanere.addElement(laaner);
        }
        if (udlaante.size()>0) {
          udskrivLaanereAfBog(titel, forfatter, laanere);
        }
        else {
          prn.println("Bogen "+titel+" er ikke udlnt");
        }
      }
      else
        if (action.equals("Bger som lner har")) {
          Vector boeger = new Vector();
          Dialogs.showMessage("Bger som lner har");
          laanerId=Laanere.laanerIdTextField.getText().trim();
          navn=Laanere.navnTextField.getText().trim();
          adresse=Laanere.adresseTextField.getText().trim();
          udlaante=DbUdlaan.selectAllWhere("LAANER_ID = '"+laanerId+"'");
          for (int i=0; i<udlaante.size(); i++) {
            Udlaan udlaan=(Udlaan) udlaante.get(i);
            Bog bog= (Bog) DbBog.selectAllWhere("ISBN = '"+udlaan.isbn+"'").get(0);
            boeger.addElement(bog);
          }
          if (boeger.size()>0) udskrivBoegerSomLaanerHar(navn, adresse, boeger);
        }
        else
          if (action.equals("Bger som skal hjemkaldes")) {
            Dialogs.showMessage("Bger som skal hjemkaldes");
            Date dato = new Date();
            udlaante=DbUdlaan.selectAllWhere("");
            for (int i=0; i<udlaante.size(); i++) {
              Udlaan udlaan=(Udlaan) udlaante.get(i);
              long dage=VisUdlaante.GetDaysBetween(udlaan.dato, dato);
              if (dage>30) {
                Bog bog = (Bog) DbBog.selectAllWhere("ISBN = '"+udlaan.isbn+"'").get(0);
                Laaner laaner = (Laaner) DbLaaner.selectAllWhere("LAANER_ID = '"+udlaan.laaner_Id+"'").get(0);
                hjemkaldBogFraLaaner(bog, laaner, dage);
              }
            }
          }
  }
}