import java.rmi.*;
import java.rmi.server.*;
import rtl.*;
import java.util.*;


public class BankKlient {
  public static void main(String[] args) {
    KbdRead kbd = new KbdRead();
    char valg;
    String navn,kontoNr;
    int saldo, beloeb;

    try {
      System.setSecurityManager(new RMISecurityManager());
      BankInterface bank = (BankInterface)Naming.lookup("rmi://localhost/bank");

      System.out.println("Linie til Bank er oprettet");

      do {
        System.out.println("1. Opret Konto ");
        System.out.println("2. Indst p konto ");
        System.out.println("3. Hv fra konto ");
        System.out.println("4. Vis Saldo ");
        System.out.println("5. Vis posteringer p konto ");
        System.out.println("6. Registrer posteringer ");
        System.out.println("7. Afslut ");
        System.out.println();
        System.out.print("Valg: "); valg=kbd.readChar();
        switch(valg) {
          case '1':
            System.out.print("Navn: "); navn=kbd.readString();
            System.out.print("Saldo: "); saldo=kbd.readInteger();
            System.out.println(bank.opretKonto(navn,saldo));
            break;
          case '2':
            System.out.print("KontoNr: "); kontoNr=kbd.readString();
            System.out.print("belb: "); beloeb=kbd.readInteger();
            if (bank.indsaetBeloeb(kontoNr, beloeb))
              System.out.println("Belbet "+beloeb+" kr. er indsat p kontoNr "+kontoNr);
            else
              System.out.println("Belbet kunne ikke indsttes p kontoNr: "+kontoNr);
            break;
          case '3':
            System.out.print("KontoNr: "); kontoNr=kbd.readString();
            System.out.print("belb: "); beloeb=kbd.readInteger();
            if (bank.haevBeloeb(kontoNr, beloeb))
              System.out.println("Belbet "+beloeb+" kr. er hvet p konto: "+kontoNr);
            else
              System.out.println("Belbet kunne ikke hves p konto: "+kontoNr);
            break;
          case '4':
            System.out.print("KontoNr: "); kontoNr=kbd.readString();
            System.out.println(bank.visSaldo(kontoNr));
            break;
          case '5':
            System.out.print("KontoNr: "); kontoNr=kbd.readString();
            Vector posteringer = bank.visEkspeditioner(kontoNr);
            if (posteringer.size()>0) {
              for (int j=0; j<posteringer.size(); j++) {
                String postering = (String)posteringer.get(j);
                System.out.println(postering);
              }
            }
            else
              System.out.println("Ingen posteringer p konto: "+kontoNr);
              break;
          case '6':
            if (bank.registrerTransaktioner())
              System.out.println("Alle posteringer er registreret i fil");
            else
              System.out.println("Posteringer kunne ikke registreres i fil");
        }
        System.out.println();
        System.out.println();
      }
      while (valg!='7');
    }
    catch(Exception e) {
      System.out.println("BankKlient: " + e);
    }

    System.exit(0);
  }
}