import rtl.*;
import java.util.*;
import java.rmi.*;
import java.rmi.server.*;


public class BankServerImpl extends UnicastRemoteObject implements BankInterface {

 private String bank;
 TextFileRead tfr;
 TextFileWrite tfw;
 private Vector konti, ekspeditioner;
 private int antalEkspeditioner;

 Date dato;
 final String KONTI_LOG = "konti.txt";
 final String EXPD_LOG = "expd_log.txt";

 public BankServerImpl(String bank) throws RemoteException {

   this.bank=bank;
   ekspeditioner = new Vector();
   int antalEkspeditioner=-1;
   String ekspedition;

   try {
   tfr = new TextFileRead(EXPD_LOG);
     do {
       ekspedition=tfr.readLine();
       if (!tfr.eof()) {
         antalEkspeditioner++;
         ekspeditioner.addElement(ekspedition);
       }
     }
     while (!tfr.eof());
     tfr.close();
   }
   catch (NullPointerException e) {
     System.out.println(e);
   }

   konti = new Vector();
   int antalKonti=-1;
   String navn, kontoNr;
   int saldo;

   try {
   tfr = new TextFileRead(KONTI_LOG);
     do {
       navn = tfr.readLine();
       if (!tfr.eof()) {
         antalKonti++;
         kontoNr = tfr.readLine();
         saldo = Integer.parseInt(tfr.readLine());
         Konto konto = new Konto(navn, kontoNr, saldo);
         konti.addElement(konto);
       }
     }
     while (!tfr.eof());
     tfr.close();
   }
   catch (NullPointerException e) {
     System.out.println("BankServerImpl: "+e);
   }
 }

 class Konto {

   String navn;
   String kontoNr;
   int saldo;
   public Konto(String navn, String kontoNr, int saldo) {
     this.navn=navn;
     this.kontoNr=kontoNr;
     this.saldo=saldo;
   }
 }

  public String opretKonto(String navn, int saldo) throws RemoteException {

    KbdRead kbd = new KbdRead();
    String kontoNr;
    int kto;
    char svar;
    System.out.print("Kan der oprettes en konto p navn: "+navn+" med saldo: "+saldo+"? j/n ");
    svar = kbd.readChar();
    if (svar=='j') {
      kto = (int) Math.round(Math.random()*100000000);
      kontoNr = ""+kto;
      konti.addElement(new Konto(navn,kontoNr,saldo));
      return "Der er oprettet en konto p navnet: "+navn+" med kontoNr."+kontoNr;
    }
    else return "Der kan ikke oprettes en konto p navnet: "+navn;
  }

  public String visSaldo(String kontoNr) throws RemoteException {

    for (int k=0; k<konti.size(); k++) {
      if (kontoNr.equals(((Konto)konti.get(k)).kontoNr))
        return "Saldoen p kontoen "+kontoNr+" er "+((Konto)konti.get(k)).saldo;
    }
      return "Konto Nr "+kontoNr+" findes ikke";
  }

  public boolean indsaetBeloeb(String kontoNr, int beloeb) throws RemoteException {

    for (int k=0; k<konti.size(); k++) {
      if (kontoNr.equals(((Konto)konti.get(k)).kontoNr)) {
    int saldo = ((Konto)konti.get(k)).saldo+beloeb;
        ((Konto)konti.get(k)).saldo = saldo;
        dato = new Date();
        String ekspedition = bank+": "+dato.toString()+" indsat "+beloeb+
                             " kr. p konto:"+kontoNr+". Saldo kr. "+saldo;
        ekspeditioner.addElement(ekspedition);
        return true;
      }
    }
    return false;
  }

  public boolean haevBeloeb(String kontoNr, int beloeb) throws RemoteException {

    for (int k=0; k<konti.size(); k++) {
      if (kontoNr.equals(((Konto)konti.get(k)).kontoNr)) {
        if ((beloeb>0) && (((Konto)konti.get(k)).saldo>=beloeb)) {
      int saldo = ((Konto)konti.get(k)).saldo-beloeb;
          ((Konto)konti.get(k)).saldo = saldo;
          dato = new Date();
          String ekspedition = bank+": "+dato.toString()+" hvet "+beloeb+
                               " kr. p konto:"+kontoNr+". Saldo kr. "+saldo;
          ekspeditioner.addElement(ekspedition);
          return true;
        }
        else return false;
      }
    }
    return false;
  }

  public Vector visEkspeditioner(String kontoNr) throws RemoteException {

    Vector ktoExpd = new Vector();
    for (int k=0; k<ekspeditioner.size(); k++) {
      String exp =(String)ekspeditioner.get(k);
      if (exp.indexOf(kontoNr)>0) ktoExpd.addElement(exp);
    }
    return ktoExpd;
  }

  public boolean registrerTransaktioner() throws RemoteException {

    try {
       tfw = new TextFileWrite(EXPD_LOG);
      for (int j=0;j<ekspeditioner.size();j++) {
        tfw.writeLine((String)ekspeditioner.get(j));
      }
      tfw.close();
    }
    catch (NullPointerException e) {
      System.out.println(e);
      return false;
    }
    try {
      tfw = new TextFileWrite(KONTI_LOG);
      for (int j=0;j<konti.size();j++) {
        tfw.writeLine(((Konto)konti.get(j)).navn);
        tfw.writeLine(((Konto)konti.get(j)).kontoNr);
        tfw.writeLine(""+((Konto)konti.get(j)).saldo);
      }
      tfw.close();
      return true;
    }
    catch (NullPointerException e) {
      System.out.println(e);
      return false;
    }
  }
}


