import rtl.*;
import java.util.*;
import java.rmi.*;
import java.rmi.server.*;

public class VarehusImpl extends UnicastRemoteObject implements VarehusInterface {

  static String varehusNavn="RMI-Varehuset";
  public static String varehusKontoNr;
  static BankInterface bank;
  public static Vector varer, ekspeditioner;
  static Vare vare;
  Date dato;

  public VarehusImpl(String varehusNavn, Vector varer, Vector ekspeditioner, String varehusKontoNr, BankInterface bank) throws RemoteException {
    this.varehusNavn=varehusNavn;
    this.varer=varer;
    this.ekspeditioner=ekspeditioner;
    this.bank=bank;
    this.varehusKontoNr=varehusKontoNr;
  }

  static synchronized void opretVare(String vareId, String beskrivelse, int antal, int pris)  {
    KbdRead kbd = new KbdRead();
    char svar;
    System.out.print("Opret vare med Vare-ID: "+vareId+"  Beskrivelse: "+
                         beskrivelse+" Antal: "+antal+" pris: "+pris+"? j/n ");
    svar = kbd.readChar();
    if (svar=='j') {
      vare = new Vare(vareId,beskrivelse,antal,pris);
      varer.addElement(vare);
      VarehusServer.opdaterVarer(varer);
    }
    else System.out.println("Oprettelsen af "+vareId+" er annulleret");
  }

  public String fjernVare(String vareId) {
    for (int k=0; k<varer.size(); k++) {
      String vareId_k=(String)((Vare)varer.get(k)).vareId;
      if (vareId.equals(vareId_k)) {
        varer.remove(k);
        dato = new Date();
        String ekspedition = varehusNavn+": "+dato.toString()+"  Varen "+vareId+" er nedlagt";
        ekspeditioner.addElement(ekspedition);
        VarehusServer.opdaterEkspeditioner(ekspeditioner);
        VarehusServer.opdaterVarer(varer);
        return ekspedition;
      }
    }
    return "Varen "+vareId+" findes ikke";
  }

  public Vector visVarer() throws RemoteException {
    return varer;
  }

  public synchronized String koebVare(String vareId, String kontoNr) throws RemoteException {
    boolean ok;
    String ekspedition;
    for (int k=0; k<varer.size(); k++) {
      ok=vareId.equals(((Vare)varer.get(k)).vareId);
      if (ok) {
        int pris=((Vare)varer.get(k)).pris;
        ok=bank.haevBeloeb(kontoNr,pris);
        if (ok) {
          ok=bank.indsaetBeloeb(varehusKontoNr, pris);
          if (ok) {
            int antal=((Vare)varer.get(k)).antal;
            if (antal>0) {
              dato = new Date();
              String beskrivelse=((Vare)varer.get(k)).beskrivelse;
              ekspedition = varehusNavn+": "+dato.toString()+" kbt "+vareId+
                     ": "+beskrivelse+" p konto:"+kontoNr;
              ekspeditioner.addElement(ekspedition);
              antal--;
              ((Vare)varer.get(k)).antal=antal;
              VarehusServer.opdaterEkspeditioner(ekspeditioner);
            }
            else {
              System.out.println("Der er ikke flere "+vareId+"p lager");
              return "Varen med vareId: "+vareId+" er udsolgt";
            }
          return ekspedition;
          }
          else return "Ekspeditionen kunne ikke foretages Banken var lukket";
        }
        else return "KontoNr: "+kontoNr+" findes ikke eller der var ikke dkning p kontoen";
      }
    }
    return "Varen med vareId: "+vareId+"  findes ikke";
  }

  public synchronized Vector visEkspeditioner(String kontoNr) throws RemoteException {
    Vector ktoExpd = new Vector();
    for (int k=0; k<ekspeditioner.size(); k++) {
      String exp =(String)ekspeditioner.get(k);
      if (exp.indexOf(kontoNr)>0) ktoExpd.addElement(exp);
    }
    return ktoExpd;
  }
}



