import rtl.*;
import java.util.*;
import org.omg.CORBA.*;
import org.omg.CosNaming.*;


public class BankKlient {
  public static void main(String[] args) {
    KbdRead kbd = new KbdRead();
    char valg;
    String navn,kontoNr;
    int saldo, beloeb;

    try {
      ORB orb = ORB.init(args, null);
      org.omg.CORBA.Object namingContextObj = null;
      namingContextObj = orb.resolve_initial_references("NameService");
      if (namingContextObj == null) System.out.println("'NameService is a null object reference");

      NamingContextExt namingContextExt = null;
      namingContextExt = NamingContextExtHelper.narrow(namingContextObj);

      BankInterface bank = null;
      String bankNavn="bank";
      try {
        bank = BankInterfaceHelper.narrow(namingContextExt.resolve_str(bankNavn));

        System.out.println("a reference is create to remote object "+bankNavn);
      }
      catch(Exception e) {
        System.out.println("could not create a reference to remote object "+bankNavn);
        System.out.println(e);
      }

      do {
        System.out.println();
        System.out.println("****** CORBA-Banken. Det betaler sig ******");
        System.out.println("1. Opret Konto ");
        System.out.println("2. Indst p konto ");
        System.out.println("3. Hv fra konto ");
        System.out.println("4. Vis Saldo ");
        System.out.println("5. Vis posteringer p konto ");
        System.out.println("6. Registrer posteringer ");
        System.out.println("7. Afslut ");
        System.out.println();
        System.out.print("Valg: "); valg=kbd.readChar();
        switch(valg) {
          case '1':
            System.out.print("Navn: "); navn=kbd.readString();
            System.out.print("Saldo: "); saldo=kbd.readInteger();
            System.out.println(bank.opretKonto(navn,saldo));
            break;
          case '2':
            System.out.print("KontoNr: "); kontoNr=kbd.readString();
            System.out.print("belb: "); beloeb=kbd.readInteger();
            if (bank.indsaetBeloeb(kontoNr, beloeb))
              System.out.println("Belbet "+beloeb+" kr. er indsat p kontoNr "+kontoNr);
            else
              System.out.println("Belbet kunne ikke indsttes p kontoNr: "+kontoNr);
            break;
          case '3':
            System.out.print("KontoNr: "); kontoNr=kbd.readString();
            System.out.print("belb: "); beloeb=kbd.readInteger();
            if (bank.haevBeloeb(kontoNr, beloeb))
              System.out.println("Belbet "+beloeb+" kr. er hvet p konto: "+kontoNr);
            else
              System.out.println("Belbet kunne ikke hves p konto: "+kontoNr);
            break;
          case '4':
            System.out.print("KontoNr: "); kontoNr=kbd.readString();
            System.out.println(bank.visSaldo(kontoNr));
            break;
          case '5':
            System.out.print("KontoNr: "); kontoNr=kbd.readString();
            String[] posteringer = bank.visEkspeditioner(kontoNr);
            if (!posteringer[0].equals("")) {
              int j=0;
              while (!posteringer[j].equals("")) {
                System.out.println(posteringer[j]);
                j++;
              }
            }
            else
              System.out.println("Ingen posteringer p konto: "+kontoNr);
              break;
          case '6':
            if (bank.registrerTransaktioner())
              System.out.println("Alle posteringer er registreret i fil");
            else
              System.out.println("Posteringer kunne ikke registreres i fil");
        }
        System.out.println();
        System.out.println();
      }
      while (valg!='7');
    }
    catch(Exception e)
    {   System.out.println("BankKlient: " + e);
        e.printStackTrace(System.out);
    }
    System.exit(0);
  }
}