unit BankInterface_impl;

{This file was generated on 3 Jan 2002 20:37:31 GMT by version 03.03.03.C1.A1 }
{of the Inprise VisiBroker idl2pas CORBA IDL compiler.                        }

{Please do not edit the contents of this file. You should instead edit and    }
{recompile the original IDL which was located in the file BankInterface.idl.  }

{Delphi Pascal unit      : BankInterface_impl                                 }
{derived from IDL module : default                                            }



interface

uses
  SysUtils,Math,
  CORBA,
  BankInterface_i,
  BankInterface_c;

const
  MaxExpd=500; MaxKonti=100; MaxKtoExpd=10; MaxRibers=20;
  kontiFilNavn='konti.txt';
  expdFilNavn='expd_log.txt';
  RibersFilNavn='Ribers.txt';
type
  TKonto=record
    navn,kontoNr:AnsiString;
    saldo:Integer;
  end;

  Tkonti=array[1..MaxKonti] of TKonto;
  TEkspeditioner=array[1..MaxExpd] of string;
  TRibers=array[1..MaxRibers] of string;
  TKtoExpd=array[1..MaxKtoExpd] of string;

  TBankInterface = class;

  TBankInterface = class(TInterfacedObject, BankInterface_i.BankInterface)
  protected
  public
    constructor Create;
    function  opretKonto ( const navn : AnsiString;
                           const saldo : Integer): AnsiString;
    function  indsaetBeloeb ( const kontoNr : AnsiString;
                              const beloeb : Integer): Boolean;
    function  visSaldo ( const kontoNr : AnsiString): AnsiString;
    function  visEkspeditioner ( const kontoNr : AnsiString): BankInterface_i.EkspeditionSeq;
    function  haevBeloeb ( const kontoNr : AnsiString;
                           const beloeb : Integer): Boolean;
    class function  registrerTransaktioner : Boolean; virtual;
    class procedure VisAlleKonti; virtual;
    class procedure VisAlleEkspeditioner; virtual;
    class procedure VisSidsteEkspedition; virtual;
    class procedure VisKundeNavn(kontoNr:string); virtual;
    class procedure VisRibersKunder;
  end;

implementation

var
    bank:AnsiString;
    dato:TDateTime;
    konti:TKonti;
    expd:TEkspeditioner;
    RibersKunder:TRibers;
    KtoExpd:TKtoExpd;
    antalKonti,antalExpd,antalRibersKunder:Integer;
    ExpdFil,KontiFil,RibersFil:TextFile;

constructor TBankInterface.Create;
var
  saldo:string;
  k:Integer;
begin
  inherited;
  bank:='CORBA-Banken';
  AssignFile(KontiFil,KontiFilNavn);
  {$I-} reset(KontiFil); {I+}
  if IoResult<>0 then
  begin
    writeln('Filen ',KontiFilNavn,' blev ikke fundet! Der oprettes en ny fil');
    rewrite(Kontifil)
  end else
  begin
    k:=0;
    while not eof(KontiFil) do
    begin
      inc(k);
      readln(KontiFil,konti[k].navn);
      readln(KontiFil,konti[k].kontoNr);
      readln(KontiFil,saldo);
      konti[k].saldo:=StrToInt(saldo);
    end;
    antalKonti:=k;
    CloseFile(KontiFil);
    writeln('Bankens konti er indlaest fra fil');
  end;
  AssignFile(expdFil,ExpdFilNavn);
  {$I-} reset(expdFil); {I+}
  if IoResult<>0 then
  begin
    writeln('Filen ',ExpdFilNavn,' blev ikke fundet! Der oprettes en ny fil');
    rewrite(expdfil)
  end else
  begin
    k:=0;
    while not eof(expdFil) do
    begin
      inc(k);
      readln(expdFil,expd[k]);
    end;
    antalExpd:=k;
    CloseFile(ExpdFil);
    writeln('Bogholderiet er indlaest fra fil');
  end;
  AssignFile(RibersFil,RibersFilNavn);
  {$I-} reset(RibersFil); {I+}
  if IoResult<>0 then
  begin
    writeln('Filen ',RibersFilNavn,' blev ikke fundet! Der oprettes en ny fil');
    rewrite(Ribersfil)
  end else
  begin
    k:=0;
    while not eof(RibersFil) do
    begin
      inc(k);
      readln(RibersFil,RibersKunder[k]);
    end;
    antalRibersKunder:=k;
    CloseFile(RibersFil);
    writeln('Bogholderiet er indlaest fra fil');
  end

  end;

function  TBankInterface.opretKonto ( const navn : AnsiString;
                                      const saldo : Integer): AnsiString;
var k:Integer;
begin
  k:=1;
  if AntalRibersKunder>0 then
  while (k<=AntalRibersKunder) and (pos(navn,RibersKunder[k])=0) do inc(k);
  if k=AntalRibersKunder+1 then
  begin
    inc(antalKonti);
    konti[antalKonti].navn:=navn;
    konti[antalKonti].saldo:=saldo;
    konti[antalKonti].kontoNr:=IntToStr(random(90)+10)+IntToStr(random(90)+10)+
                               IntToStr(random(90)+10)+IntToStr(random(90)+10);
    opretKonto:='Der er oprettet en konto p navnet: '+navn+' med kontoNr: '+
                konti[antalKonti].kontoNr;
  end else opretKonto:='Der kan ikke oprettes en konto p navnet: '+navn+
                       ' da, De er registreret som daarlig betaler';
end;

function  TBankInterface.indsaetBeloeb ( const kontoNr : AnsiString;
                                         const beloeb : Integer): Boolean;
var k:Integer;
begin
  k:=1;
  while (konti[k].kontoNr<>kontoNr) and (k<antalKonti) do inc(k);
  if konti[k].kontoNr=kontoNr then
  begin
    konti[k].saldo:=konti[k].saldo+beloeb;
    dato:=Now;
    antalExpd:=antalExpd mod MaxExpd +1;
    expd[antalExpd]:=bank+': '+DateTimeToStr(dato)+' er indsat '+
      IntTostr(beloeb)+' kr. Kto: '+kontoNr+'. Saldo: '+
      IntTostr(konti[k].saldo)+' kr.';
    indsaetBeloeb:=true
  end else indsaetBeloeb:=false
end;

function  TBankInterface.visSaldo ( const kontoNr : AnsiString): AnsiString;
var k:Integer;
begin
  k:=1;
  while (konti[k].kontoNr<>kontoNr) and (k<antalKonti) do inc(k);
  if konti[k].kontoNr=kontoNr then
    visSaldo:='Saldoen p kontoen '+kontoNr+' er '+IntToStr(konti[k].saldo)
  else  visSaldo:='Konto Nr '+kontoNr+' findes ikke'
end;

function  TBankInterface.visEkspeditioner ( const kontoNr : AnsiString):
                                            BankInterface_i.EkspeditionSeq;
var k,j:Integer;
begin
  for j:=1 to MaxKtoExpd do ktoExpd[j]:='';
  j:=0;
  for k:=1 to antalExpd do
  begin
    if pos(kontoNr,expd[k])>0 then
    begin
      inc(j); ktoExpd[j]:=expd[k]
    end
  end;
  visEkspeditioner:=EkspeditionSeq(ktoexpd)
end;

function  TBankInterface.haevBeloeb ( const kontoNr : AnsiString;
                                      const beloeb : Integer): Boolean;
var
  k,haevet:Integer;
  RibersExpd:string;
begin
  k:=1;
  while (k<=antalKonti) and (konti[k].kontoNr<>kontoNr) do inc(k);
  if k<antalKonti+1 then
  begin
    if konti[k].saldo>=beloeb then
    begin
      konti[k].saldo:=konti[k].saldo-beloeb;
      dato:=Now;
      antalExpd:=antalExpd mod MaxExpd +1;
      expd[antalExpd]:=bank+': '+DateTimeToStr(dato)+' er hvet '+
      IntTostr(beloeb)+' kr. Kto:'+kontoNr+'. Saldo'+
      IntTostr(konti[k].saldo)+' kr.';
      haevBeloeb:=true
    end else
    begin
      haevet:=konti[k].saldo;
      konti[k].saldo:=0;
      antalExpd:=antalExpd mod MaxExpd +1;
      expd[antalExpd]:=bank+': '+DateTimeToStr(dato)+' er hvet '+
      IntTostr(haevet)+' kr. Kto:'+kontoNr+'. Saldo'+
      IntTostr(konti[k].saldo)+' kr.';
      inc(AntalRibersKunder);
      RibersExpd:=bank+': '+DateTimeToStr(dato)+': '+konti[k].navn;
      RibersKunder[AntalRibersKunder]:=RibersExpd;
      inc(antalExpd);
      Expd[antalExpd]:=RibersExpd;
      haevBeloeb:=false
    end
  end else haevBeloeb:=false
end;

class function  TBankInterface.registrerTransaktioner : Boolean;
var k:Integer;
begin
  try
    AssignFile(KontiFil,KontiFilNavn); rewrite(KontiFil);
    for k:=1 to antalKonti do
    begin
      writeln(KontiFil,konti[k].navn);
      writeln(KontiFil,konti[k].kontoNr);
      writeln(KontiFil,IntToStr(konti[k].saldo));
    end;
    CloseFile(KontiFil);
    AssignFile(expdFil,ExpdFilNavn); rewrite(ExpdFil);
    for k:=1 to antalExpd do writeln(ExpdFil,Expd[k]);
    CloseFile(ExpdFil);
    AssignFile(RibersFil,RibersFilNavn); rewrite(RibersFil);
    for k:=1 to antalRibersKunder do writeln(RibersFil,RibersKunder[k]);
    CloseFile(RibersFil);

    registrerTransaktioner:=true;
  except
    registrerTransaktioner:=false
  end
end;

class procedure TBankInterface.VisAlleKonti;
var k:Integer;
begin
  writeln('Liste over de ',antalKonti,' kontohavere i ',bank);
  for k:=1 to antalKonti do
    writeln('Navn: ',konti[k].navn,'. Kto: ',konti[k].KontoNr,'. Saldo: ',
            IntToStr(konti[k].saldo))
end;

class procedure TBankInterface.VisAlleEkspeditioner;
var k:Integer;
begin
  writeln('Liste over de sidste ',antalExpd,' i ',bank);
  for k:=1 to antalExpd do writeln(expd[k])
end;

class procedure TBankInterface.VisSidsteEkspedition;
begin
 if antalExpd>0 then writeln(expd[antalExpd])
end;

class procedure TBankInterface.VisKundeNavn(kontoNr:string);
var k:Integer;
begin
  if antalKonti>0 then
  begin
    k:=1;
    while (k<=antalKonti) and (konti[k].kontoNr<>kontoNr) do inc(k);
    if konti[k].kontoNr=kontoNr then
      writeln('Kontohaveren p konto: ',kontonr,' er ',konti[k].navn)
    else
      writeln('Der findes ingen Kontohaver p konto: ',kontonr)
  end
end;

class procedure TBankInterface.VisRibersKunder;
var k:Integer;
begin
  writeln('Liste over de registrerede ',antalRibersKunder,' Ribers kunder i ',bank);
  for k:=1 to antalRibersKunder do writeln(RibersKunder[k])
end;

initialization

end.