program BankServer;
{$APPTYPE CONSOLE}

uses
  SysUtils,
  Corba,COSNaming,
  BankInterface_i in 'BankInterface_i.pas',
  BankInterface_impl in 'BankInterface_impl.pas',
  BankInterface_s in 'BankInterface_s.pas',
  BankInterface_c in 'BankInterface_c.pas';

var
  BankNavn,kontoNr:string;
  valg:Char;
  bank:TBankInterfaceSkeleton;
  RootContext : NamingContext;
  nameComp : NameComponent;
  nameArray : COSNaming.Name;

begin
  BankNavn:='CORBA-Banken';
  try
    CorbaInitialize;
    // Create the server and register with the BOA
    bank := TBankInterfaceSkeleton.Create(BankNavn, TBankInterface.Create);
    writeln('BankInterface object created...');writeln;
    BOA.ObjIsReady(bank as _Object);
    //Get the Naming Service Root Context via the ORB
    RootContext := TNamingContextHelper.
                   Narrow(Orb.ResolveInitialReferences('NameService'), True);
    //Create the naming component -- match server id and kind values
    nameComp := TNameComponent.Create('bank','');
    //set up the Name sequence
    SetLength(NameArray, 1);
    NameArray[0] := nameComp;
    // now bind with the Naming Service
    RootContext.rebind(NameArray, bank as CorbaObject);
    writeln('Server is ready');
    writeln;
    writeln('******* '+BankNavn+' *******');
    writeln;
    repeat
      writeln;
      writeln('1. Vis Alle Konti ');
      writeln('2. Vis Alle Ekspeditioner ');
      writeln('3. Find Kunde navn');
      writeln('4. Vis sidste ekspedition');
      writeln('5. Registrer posteringer ');
      writeln('6. Vis kunder i Ribers kartotek');
      writeln('7. Afslut');
      writeln;
      write('Valg: '); readln(valg);
      case valg of
        '1': TBankInterface.VisAlleKonti;
        '2': TBankInterface.VisAlleEkspeditioner;
        '3': begin
               write('KontoNr: '); readln(kontoNr);
               TBankInterface.VisKundenavn(KontoNr);
             end;
         '4': TBankInterface.VisSidsteEkspedition;
         '5': if TBankInterface.registrerTransaktioner then
                writeln('Alle posteringer er registreret i fil')
              else writeln('Posteringer kunne ikke registreres i fil');
         '6': TBankInterface.VisRibersKunder;
      end;
    until valg='7';
    bank.Free;
    //BOA.ImplIsReady;
  except
    on E:Exception do writeln('Server: ',E.Message)
  end;
end.


