import rtl.*;
import java.util.*;
import org.omg.CORBA.*;
import org.omg.CosNaming.*;


public class BankKlient {
  public static void main(String[] args) {
    KbdRead kbd = new KbdRead();
    char valg;
    String navn,kontoNr;
    int saldo, beloeb;

    try {
      ORB orb = ORB.init(args, null);
      org.omg.CORBA.Object namingContextObj = null;
      namingContextObj = orb.resolve_initial_references("NameService");
      if (namingContextObj == null) System.out.println("NameService is a null object reference");

      NamingContextExt namingContextExt = null;
      namingContextExt = NamingContextExtHelper.narrow(namingContextObj);

      BankInterface bank = null;
      String bankNavn="bank";
      try {
        bank = BankInterfaceHelper.narrow(namingContextExt.resolve_str(bankNavn));

        System.out.println("a reference is created to remote object "+bankNavn);
      }
      catch(Exception e) {
        System.out.println("could not create a reference to remote object "+bankNavn);
        System.out.println(e);
      }

      do {
        System.out.println();
        System.out.println("****** CORBA-Banken. Det betaler sig ******");
        System.out.println("1. Opret Konto ");
        System.out.println("2. Indsaet paa konto ");
        System.out.println("3. Haev fra konto ");
        System.out.println("4. Vis Saldo ");
        System.out.println("5. Vis posteringer paa konto ");
        System.out.println("6. Afslut ");
        System.out.println();
        System.out.print("Valg: "); valg=kbd.readChar();
        switch(valg) {
          case '1':
            System.out.print("Navn: "); navn=kbd.readString();
            System.out.print("Saldo: "); saldo=kbd.readInteger();
            System.out.println(bank.opretKonto(navn,saldo));
            break;
          case '2':
            System.out.print("KontoNr: "); kontoNr=kbd.readString();
            System.out.print("beloeb: "); beloeb=kbd.readInteger();
            if (bank.indsaetBeloeb(kontoNr, beloeb))
              System.out.println("Beloebet "+beloeb+" kr. er indsat paa kontoNr "+kontoNr);
            else
              System.out.println("Beloebet kunne ikke indsaettes paa kontoNr: "+kontoNr);
            break;
          case '3':
            System.out.print("KontoNr: "); kontoNr=kbd.readString();
            System.out.print("beloeb: "); beloeb=kbd.readInteger();
            if (bank.haevBeloeb(kontoNr, beloeb))
              System.out.println("Beloebet "+beloeb+" kr. er haevet paa konto: "+kontoNr);
            else
              System.out.println("Beloebet kunne ikke haeves paa konto: "+kontoNr+
                                 ". Se kvittering for begrundelse");
            break;
          case '4':
            System.out.print("KontoNr: "); kontoNr=kbd.readString();
            System.out.println(bank.visSaldo(kontoNr));
            break;
          case '5':
            System.out.print("KontoNr: "); kontoNr=kbd.readString();
            String[] posteringer = bank.visEkspeditioner(kontoNr);
            if (!posteringer[0].equals("")) {
              int j=0;
              while (!posteringer[j].equals("")) {
                System.out.println(posteringer[j]);
                j++;
              }
            }
            else
              System.out.println("Ingen posteringer paa konto: "+kontoNr);
        }
        System.out.println();
        System.out.println();
      }
      while (valg!='6');
    }
    catch(Exception e)
    {   System.out.println("BankKlient: " + e);
        e.printStackTrace(System.out);
    }
    System.exit(0);
  }
}