import rtl.*;
import java.util.*;
import org.omg.CORBA.*;
import org.omg.CosNaming.*;

public class BankServer {

  public static void main(String[] args) {
    try {
      System.out.println("Creating and initializing the ORB ect.");

      ORB orb = ORB.init(args, null);

      System.out.println ("Registering server implementation with the ORB ect.");

      BankServerImpl bankServerImpl = new BankServerImpl("CORBA-Banken");

      orb.connect(bankServerImpl);

      System.out.println(orb.object_to_string(bankServerImpl));

      String[] services = orb.list_initial_services();
      System.out.println("Naming Services");
      for (int k=0; k<services.length; k++) System.out.println(services[k]);

      org.omg.CORBA.Object namingContextObj = orb.resolve_initial_references("NameService");

      NamingContext namingContext = NamingContextHelper.narrow(namingContextObj);

      NameComponent[] path = {  new NameComponent("bank", "Object") };

      System.out.println ("Binding server implementation to name service...");

      namingContext.rebind(path, bankServerImpl);

      System.out.println("Venter p henvendelse fra Klienter");

      java.lang.Object sync = new java.lang.Object();

      synchronized (sync) {
        sync.wait();
      }
    }
    catch (Exception e) {   System.err.println("BankServer: "+e);
        e.printStackTrace(System.out);
    }
  }
}


