import rtl.*;

public class EightQueens {

  static boolean onBoard(byte x) {
    return (x>0) && (x<9);
  }

  static boolean[] freeRow(byte row, byte[] queens) {
    byte x,y;
    boolean[] free = new boolean[9];
    for (x=1; x<=8; x++) free[x]=true;
    for (y=1; y<row; y++) {
      free[queens[y]]=false;
      x=(byte)(row-y+queens[y]);
      if (onBoard(x)) free[x]=false;
      x=(byte)(y-row+queens[y]);
      if (onBoard(x)) free[x]=false;
    }
    return free;
  }

  static void writeSolution(byte[] queens) {
    KbdRead kbd = new KbdRead();
    byte x,y;
    char ch;
    for (y=8; y>=1; y--) {
      System.out.print(""+y);
      for (x=1; x<=8; x++) {
        if (queens[y]==x) System.out.print("D"+y);
        else
          if ((x+y) % 2==0) System.out.print("  ");
          else {
            String hvidtFelt=""+(char)219+""+(char)219;
            System.out.print(hvidtFelt);
          }
      }
      System.out.println();
    }
    System.out.print(" ");
    for (x=1; x<=8; x++)
    System.out.print(""+(char)((int)('A')+(int)x -1)+" ");
    System.out.println();
    for (x=1; x<=8; x++) {
      String bogstav=""+(char)((int)('A')+(int)queens[x] -1);
      System.out.println("D"+x+" p "+bogstav+x);
    }
    System.out.print("Tryk p en Tast");
    ch=kbd.readChar();
  }

  public static void main(String[] args) {
    byte[] queens = new byte[9];
    byte x,y;
    boolean[][] freeField = new boolean[9][9];
    for (byte queen1=1; queen1<=4; queen1++) {
      for (y=1; y<=8; y++) queens[y]=0;
      queens[1]=queen1;
      y=2; freeField[2]=freeRow(y,queens);
      for (byte queen2=1; queen2<=8; queen2++) {
        if(freeField[2][queen2]) {
          queens[2]=queen2;
           y=3; freeField[3]=freeRow(y,queens);
          for (byte queen3=1; queen3<=8; queen3++) {
            if(freeField[3][queen3]) {
              queens[3]=queen3;
              y=4; freeField[4]=freeRow(y,queens);
              for (byte queen4=1; queen4<=8; queen4++) {
                if(freeField[4][queen4]) {
                  queens[4]=queen4;
                  y=5; freeField[5]=freeRow(y,queens);
                  for (byte queen5=1; queen5<=8; queen5++) {
                    if(freeField[5][queen5]) {
                      queens[5]=queen5;
                      y=6; freeField[6]=freeRow(y,queens);
                      for (byte queen6=1; queen6<=8; queen6++) {
                        if(freeField[6][queen6]) {
                          queens[6]=queen6;
                          y=7; freeField[7]=freeRow(y,queens);
                          for (byte queen7=1; queen7<=8; queen7++) {
                            if(freeField[7][queen7]) {
                              queens[7]=queen7;
                              y=8; freeField[8]=freeRow(y,queens);
                              for (byte queen8=5; queen8<=8; queen8++) {
                                if(freeField[8][queen8]) {
                                  queens[8]=queen8;
                                  writeSolution(queens);
                                }
                              }
                            }
                          }
                        }
                      }
                    }
                  }
                }
              }
            }
          }
        }
      }
    }
  }
}

