import java.io.*;
import java.util.*;
import rtl.*;

public class LottoKontrolStatic {

  public static byte[] lavRaekke() {
    byte[] rk=new byte[8];
    byte j=1,lt=0;
    for (int i=1; i<8; i++) {
      do {
        lt=(byte) (Math.random()*36+1);
        rk[i]=lt; j=1;
        while (rk[j]!=lt) j++;
      }
      while(i!=j);
    }
    return rk;
  }

  public static byte kontrollerRaekke(byte rk[], byte vinder[]) {
    byte rigtige=0;
    byte i=0;
    byte j=1;
    do {
      i++;
      while((j<7) && (vinder[i]>rk[j])) j++;
      if (vinder[i]==rk[j]) rigtige++;
    }
    while ((i<7) && (j<7));
    return rigtige;
  }

  public static void main(String args[]) {
    ParseNumbers pns=new ParseNumbers();
    KbdRead kbd=new KbdRead();
    int antal=0,praemie=0;
    char key;
    byte[] raekke=new byte[8];
    byte[][] raekkeTabel=new byte[1000000][8];
    int[] praemier={0,0,0,0,0,0};
    do {
      System.out.print("G)enerer rkker, S)riv til fil, L)s fra fil, K)ontroller A)fslut: ");
      key=kbd.readChar();
      switch (key) {
      case 'g': System.out.print("Hvor mange lottorkker skal der laves? ");
        antal=kbd.readInteger();
        long startTid = new Date().getTime();
        for (int k=0; k<antal; k++) {
          raekke=lavRaekke();
          Arrays.sort(raekke);
          raekkeTabel[k]=raekke;
        }
        long slutTid = new Date().getTime();
        long msek = (int)(slutTid-startTid);
        System.out.println("Det tog "+msek+" ms at lave "+antal+" lottorkker");
        break;

      case 's': System.out.print("Skriv filnavnet: (f.eks lotto.txt) ");
        String filnavn1=kbd.readString();
        TextFileWrite txt=new TextFileWrite(filnavn1);
        for (int k=0; k<antal; k++) {
          String line="";
          for (int j=1;j<8;j++) line=line+raekkeTabel[k][j]+" ";
          txt.writeLine(line);
        }
        txt.close();
        break;

      case 'l':System.out.print("Skriv filnavnet: (f.eks lotto.txt) ");
        String filnavn=kbd.readString();
        TextFileRead tin=new TextFileRead(filnavn);
        int[] srk=new int[8];
        antal=-1;
        try {
          while (!tin.eof()) {
            String line="";
            line=tin.readLine();
            if (!tin.eof()) {
              antal++;
              srk=pns.parseIntegers(line);
              if (srk[0]!=7) System.out.println("Fejl i tekstfilen i linie "+antal+". Ikke 7 tal p linien");
              for (int j=1;j<8;j++) raekkeTabel[antal][j]=(byte)srk[j];
            }
          }
        }
        catch (NullPointerException e) {
        }

        tin.close();
        break;

      case 'k': System.out.println("Skriv vinder rkken som heltal adskilt af mellemrum, f.eks (3 12 16 17 24 28 33)");
         String vinderStr=kbd.readString();
         System.out.println("Skriv tillgstallene som heltal adskilt af mellemrum, f.eks (8 31)");
         String tillaegsTalStr=kbd.readString();
         byte[] tillaegsTal=new byte[3];
         int [] ints=new int[8];
         byte[] vinder=new byte[8];
         ints=pns.parseIntegers(vinderStr);
         for (int j=0;j<8;j++) vinder[j]=(byte) ints[j];
         ints=pns.parseIntegers(tillaegsTalStr);
         for (int j=1;j<3;j++) tillaegsTal[j]=(byte)ints[j];
         startTid = new Date().getTime();
         for (int k=0;k<antal;k++) {
             raekke=raekkeTabel[k];
           int rigtige=kontrollerRaekke(raekke,vinder);
           if (rigtige==6) {
            praemie=3;
            for (int i=1;i<8;i++)
              if ((raekke[i]==tillaegsTal[1]) || (raekke[i]==tillaegsTal[2])) praemie=2;
           }
           else
           if (rigtige==7) praemie=1;
           else
           if ((rigtige>3)&&(rigtige<6)) praemie=9-rigtige;
           else praemie=0;
           praemier[praemie]++;
         }
         slutTid = new Date().getTime();
         msek = (int)(slutTid-startTid);
         System.out.println("Det tog "+msek+" ms at kontrollere "+antal+" lottorkker for prmier");
         System.out.println("Resultat af spillet p "+antal+" rkker");
         for (int k=1; k<6; k++)
          System.out.println("Der var "+praemier[k]+" "+k+". prmier");
          break;
      }
    }
    while(key!='a');
  }

}





