package rtl;
import java.io.*;

public class ObjectFileRead {

  FileInputStream fileInputStream;
  boolean endOfFile=false;

  public ObjectFileRead(String filename) {
    try {
      fileInputStream = new FileInputStream(filename);
    }
    catch (FileNotFoundException e) {
      System.out.println("File"+filename+" not found :"+e);
    }
  }

  public Object readFile() {
    Object object=null;
    try {
      ObjectInputStream objectInputStream = new ObjectInputStream(fileInputStream);
      object = (Object)objectInputStream.readObject();
      return object;
    }
    catch (IOException e) {
      endOfFile=true;
    }
    catch (ClassNotFoundException e) {
          System.out.println("ClassNotFoundException :"+e.getMessage());
    }
    return object;
  }

  public void close() {
  try {
      fileInputStream.close();
    }
    catch (IOException e) {
      System.out.println("IOException :"+e);
    }
  }


  public boolean eof() {
    return endOfFile;
  }
}

