import java.io.*;
import java.util.*;
import rtl.*;

public class CykelProject {
  public static void main(String args[]) {

    KbdRead kbd=new KbdRead();
    String maerke;
    byte gear;
    char key;
    double[] koor=new double[2];
    int retning=0,grader=0,rmp=0,tid=0,diam=0;
    double x,y,fart;
    Cykel cykel;

    System.out.print("Skriv fabrikatet p din nye cykel: ");
    maerke=kbd.readString();
    System.out.print("Skriv hjuldiameter p din nye cykel i cm: ");
    diam=kbd.readInteger();
    System.out.print("Er det en A)lmindelig, G)earcykel, R)acerCykel ? ");
    key=kbd.readChar();
    switch (key) {
      case 'a': cykel = new Cykel(maerke,(double)diam/100.,22./8.);
            break;
      case 'g': cykel = new CykelGear(maerke,(double)diam/100.);
            break;
      case 'r': cykel= new CykelRacer(maerke,(double)diam/100.);
            break;
      default:  cykel= new Cykel(maerke,diam/100,22/8);
    }

    System.out.println("Tillykke med din nye "+maerke+" cykel!");
    do {
      System.out.print("M)rke, K)r, D)rej, F)art, R)etning, Skift G)ear, P)osition, A)fslut: ");
      key=kbd.readChar();
      switch (key) {
        case 'm': maerke=cykel.visMaerke();
              System.out.println(" Din cykel er en "+maerke+"  "+cykel.toString());
              break;
        case 'k': System.out.print(" Ny pedalgang i rmp; ");
              rmp=kbd.readInteger();
              System.out.print("Krselstid: i sekunder ");
              tid=kbd.readInteger();
              cykel.koer(rmp,tid);
              break;
        case 'd': System.out.print("Drejning af styret i grader (positiv: til venstre): ");
              grader=kbd.readInteger();
              if (cykel.drej(grader))
              System.out.println("Krash... Du drejede for skarpt og vltede!");
              break;
        case 'g': if (cykel instanceof CykelRacer) {
                System.out.print("Du krer i "+((CykelRacer)cykel).visGear()+" gear. Angiv nyt gear 1..10 ");
                gear=(byte)kbd.readInteger();
                if ((gear>0) && (gear<=(int)((CykelRacer)cykel).gearVaelger[0]))
                ((CykelRacer)cykel).skiftGear(gear);
                else System.out.println("Du har kun 10 gear p din cykel! Kvaj!");
              }
              else
              if (cykel instanceof CykelGear) {
                System.out.print("Du krer i "+((CykelGear)cykel).visGear()+" gear. Angiv nyt gear 1..3 ");
                gear=(byte)kbd.readInteger();
                if ((gear>0) && (gear<=(int)((CykelGear)cykel).gearVaelger[0]))
                  ((CykelGear)cykel).skiftGear(gear);
                else System.out.println("Du har kun 3 gear p din cykel! Kvaj!");
              }
              else System.out.println("Du kan ikke skifte gear, nr du ikke har noget! Kvaj");
              break;
        case 'f': fart=cykel.visFart();
              double fartkmh=(int)(fart*36)/10.0;
              System.out.println("Farten er "+fartkmh+" km/h");
              break;
        case 'p': koor=cykel.visPosition();
              for(int k=0;k<=1;k++) koor[k]=(int)(koor[k]*10)/10.0;
              System.out.println("Positionen er (x,y) = ("
              +koor[0]+" m , "+koor[1]+" m)");
              break;
        case 'r': retning=cykel.visRetning();
              System.out.println("Retningen er "+retning+" grader");
              break;
      }

    }
    while (key!='a');

  }
}

class Cykel {
  protected String  maerke;
  protected double hjuldiam ,udveksling,x,y,fart;
  protected int retning,rmp;

  Cykel(String maerke, double hjuldiam ,double udveksling) {
    retning=0;
    fart=0;
    rmp=0;
    this.maerke=maerke;
    this.hjuldiam=hjuldiam;
    this.udveksling=udveksling;
  }

  public String visMaerke() {
    return maerke;
  }

  public void koer(int rmp, int tid) {
    this.rmp=rmp;
    double pi=Math.PI;
    fart=pi*hjuldiam*udveksling/60.0*rmp;
    double s=fart*tid;
    x=x+s*Math.cos(retning*pi/180);
    y=y+s*Math.sin(retning*pi/180);
  }

  public boolean drej(int grader) {
    double rad=grader*Math.PI/180;
    boolean styrt;
    if (fart<1) styrt=Math.abs(grader)>45;
    else styrt=Math.abs(Math.tan(rad))>1/fart;
    if(!styrt) retning=retning+grader;
    return styrt;
  }

  public double[] visPosition() {
    double[] koor=new double[2];
    koor[0]=x; koor[1]=y;
    return koor;
  }

  public double visFart() {
    return fart;
  }

  public int visRetning() {
    return retning;
  }
}

class CykelGear extends Cykel {
  protected byte gear;
  protected double[] gearVaelger=new double[13];

  CykelGear(String maerke, double hjuldiam) {
      super(maerke,hjuldiam,22./10.);
    gearVaelger[0]=3;
    gearVaelger[1]=22./10.; gearVaelger[2]=22./8.; gearVaelger[3]=22./6.;
    gear=1;
  }

  public double visFart() {
    udveksling=gearVaelger[gear];
    return super.visFart();
  }

  public byte visGear() {
      return gear;
  }

  public void skiftGear(byte gear) {
    this.gear=gear;
    udveksling=gearVaelger[gear];
  }
}

class CykelRacer extends CykelGear {
  CykelRacer(String maerke, double hjuldiam) {
    super(maerke,hjuldiam);
    gearVaelger[0]=10;
    gearVaelger[10]=22./6.; gearVaelger[9]=22./7.; gearVaelger[8]=22./8.;
    gearVaelger[7]=22./9.; gearVaelger[6]=22./10.; gearVaelger[5]=16./6.;
    gearVaelger[4]=16./7.; gearVaelger[3]=16./8.; gearVaelger[2]=16./9.;
    gearVaelger[1]=16./10.;
    this.udveksling=gearVaelger[1];
  }
}
