//BankKonto.java - signal/wait syncronization

import rtl.*;
import java.util.*;
public class BankKonto {

  public static void main(String[] args ) {
    Bank bank = new Bank();
    System.out.println("Banken er ben");
    Indsaette indsaette_1 = new Indsaette(bank,'1');
    Indsaette indsaette_2 = new Indsaette(bank,'2');
    Haeve haeve_3 = new Haeve(bank,'3');
    Haeve haeve_4 = new Haeve(bank,'4');
    Saldo saldo_5 = new Saldo(bank,'5');
    Saldo saldo_6 = new Saldo(bank,'6');
    indsaette_1.start();
    indsaette_2.start();
    haeve_3.start();
    haeve_4.start();
    saldo_5.start();
    saldo_6.start();
  }
}

class Indsaette extends Thread {
  private Bank bank;
  private char id;
  Indsaette(Bank bank, char id) {
    this.bank=bank;
    this.id=id;
  }
  public void run() {
    for (int i=0; i<=4; i++) {
      int kr = (int)(Math.random()*1000);
      bank.indsaet(id,kr);
    }
    System.out.println("Banken er lukket for indskud");
  }
}

class Haeve extends Thread {
  private Bank bank;
  private char id;
  Haeve(Bank bank, char id) {
    this.bank=bank;
    this.id=id;
  }
  public void run() {
    for (int i=0; i<=4; i++) {
      int kr = (int)(Math.random()*1000);
      bank.haev(id,kr);
    }
    System.out.println("Banken er lukket for udbetaling");
  }
}


class Saldo extends Thread {
  private Bank bank;
  private char id;
  Saldo(Bank bank, char id) {
    this.bank=bank;
    this.id=id;
  }
  public void run() {
    for (int i=0; i<=4; i++) {
      int saldo=bank.saldo();
      System.out.println("KundeID: "+id+": Saldoen er "+saldo);
    }
    System.out.println("Banken er lukket for saldo");
  }
}


class Bank {
  static KbdRead kbd = new KbdRead();
  private boolean transaktion=false;
  private int saldo=0;
  private char ch='n';

  synchronized void indsaet(char id, int kr) {
    while(transaktion)
    try {
      wait();
    }
    catch(InterruptedException e) {
      System.out.println("wait er blevet afbrudt "+e);
    }
    transaktion=true;
    int temp=saldo+kr;
    System.out.print("KundeID: "+id+": Der er indsat "+kr+". Saldoen er "+temp+" Godkend: j/n ");
    ch = kbd.readChar();
    if (ch=='j') saldo=saldo+kr;
    transaktion=false;
    notifyAll();
  }

  synchronized void haev(char id, int kr) {
    while(transaktion)
    try {
      wait();
    }
    catch(InterruptedException e) {
      System.out.println("wait er blevet afbrudt "+e);
    }
    transaktion=true;
    int temp=saldo-kr;
    System.out.print("KundeID: "+id+": Der er hvet "+kr+". Saldoen er "+temp+" Godkend: j/n ");
    ch = kbd.readChar();
    if (ch=='j') saldo=saldo-kr;
    transaktion=false;
    notifyAll();
  }

  synchronized int saldo() {
    while(transaktion)
    try {
      wait();
    }
    catch(InterruptedException e) {
      System.out.println("wait er blevet afbrudt "+e);
    }
    return saldo;
  }
}