import java.awt.*;
import java.awt.image.BufferedImage;

public class KugleAnimationApplet extends java.applet.Applet {

  Image bufImage = null;

  Graphics ImageGraphics;

  int[] x = new int[5];
  int[] y = new int[5];
  int[] vx = new int[5];
  int[] vy = new int[5];

  byte antal=5;

  int tid=0;

  static int width,height;

  final static int R=20;
  final static int DT=2;
  final static int V0=10;

  byte[] farve = new byte[5];

  public void paint(Graphics screen) {

    height=getBounds().height;
    width=getBounds().width;

    for (int k=0; k<antal; k++) {
      double w=(double)width;
      double h=(double)height;
      double v0=(double)V0;
      double startVinkel=(Math.random()*2-1)*Math.PI;
      x[k]=(int)(Math.random()*0.8*w+0.1*w);
      y[k]=(int)(Math.random()*0.8*h+0.1*h);
      vx[k]=(int) (v0*Math.cos(startVinkel));
      vy[k]=(int) (v0*Math.sin(startVinkel));
      farve[k]=(byte)k;
    }

    if (bufImage==null) {
      bufImage = new BufferedImage (getBounds().width, getBounds().height, BufferedImage.TYPE_INT_RGB);
      ImageGraphics = bufImage.getGraphics();
    }

    do {
      tid=tid+DT;
      ImageGraphics.setColor(Color.lightGray);
      ImageGraphics.fillRect(0,0, width, height);
      tegnKugler(ImageGraphics);
      delay(50);
      screen.drawImage(bufImage,0,0,this);
      flytKugler();

    }
    while(tid<1000);
    stop();
  }

  public void tegnKugler(Graphics g) {

    for (int k=0; k<(int)antal; k++) {
      switch (farve[k]) {
        case 0: g.setColor(Color.black); break;
        case 1: g.setColor(Color.white); break;
        case 2: g.setColor(Color.red); break;
        case 3: g.setColor(Color.green); break;
        case 4: g.setColor(Color.blue);
      }
      g.fillOval(x[k]-R,y[k]-R,2*R,2*R);
    }
  }

  private void delay (int millis) {
    try {
      Thread.sleep(millis);
    }
    catch (Exception ignored) {}
  }

  public void flytKugler() {
    for (int k=0; k<(int)antal; k++) {
      x[k]=x[k]+vx[k]*DT;
      y[k]=y[k]+vy[k]*DT;
      if ((x[k]+R>=width)||(x[k]-R<=0)) vx[k]=-vx[k];
      if ((y[k]+R>=height)||(y[k]-R<=0)) vy[k]=-vy[k];
    }
  }
}
