//MiniRegnerApplet - GridLayout Demo

import java.awt.*;
import java.applet.*;
import java.awt.event.*;
import javax.swing.*;

public class MiniRegnerApplet extends Applet {
  public void init() {

// Frame er rammen om vinduet indeholdende selve vinduet
// Pane er vinduet, hvor man kan anbringe komponenter i en Container

    JFrame frame = new JFrame("MiniRegner");
    Container pane = frame.getContentPane();

// Lav de forskellige komponenter.

    JTextField foersteTextField = new JTextField(10);
    JTextField andetTextField = new JTextField(10);
    JTextField resultatTekstField = new JTextField(10);

    JButton additionsButton = new JButton("Addition");
    JButton subtraktionsButton = new JButton("Subtraktion");
    JButton multiplikationsButton = new JButton("Multiplikation");
    JButton divisionsButton = new JButton("Division");

//  I GridLayout vil der vre 5 rkker med hver 2 komponenter

    pane.setLayout(new GridLayout(5,2));

    pane.add(new JLabel("Skriv det frste tal"));
    pane.add(foersteTextField);
    pane.add(new JLabel("Skriv det andet tal"));
    pane.add(andetTextField);
    pane.add(new JLabel("Resultat"));
    pane.add(resultatTekstField);

    pane.add(additionsButton);
    pane.add(subtraktionsButton);
    pane.add(multiplikationsButton);
    pane.add(divisionsButton);

//  Lav en "listener" til de to Buttons.

    UdfoerRegningListener udfoerRegningListener =
                      new UdfoerRegningListener(foersteTextField, andetTextField, resultatTekstField);

    additionsButton.addActionListener(udfoerRegningListener);
    subtraktionsButton.addActionListener(udfoerRegningListener);
    multiplikationsButton.addActionListener(udfoerRegningListener);
    divisionsButton.addActionListener(udfoerRegningListener);

    frame.pack();
    frame.show();
  }
}
class UdfoerRegningListener implements ActionListener {
  private JTextField foersteTextField, andetTextField, resultatTekstField;

  UdfoerRegningListener(JTextField foersteTextField, JTextField andetTextField, JTextField resultatTekstField) {
    this.foersteTextField = foersteTextField;
    this.andetTextField = andetTextField;
    this.resultatTekstField = resultatTekstField;
  }
  public void actionPerformed(ActionEvent actionEvent) {
    double foersteTal,andetTal;

// Konverter tallene, renset for blanktegn (trim) til tal (double)

    foersteTal = Double.parseDouble(foersteTextField.getText().trim());
    andetTal = Double.parseDouble(andetTextField.getText().trim());

// Undersg regningsarten, foretag udreningen og skriv resultatet.

    if (actionEvent.getActionCommand().equals("Addition"))
      resultatTekstField.setText(String.valueOf(foersteTal+andetTal));
    else
      if (actionEvent.getActionCommand().equals("Subtraktion"))
        resultatTekstField.setText(String.valueOf(foersteTal-andetTal));
      else
        if (actionEvent.getActionCommand().equals("Multiplikation"))
          resultatTekstField.setText(String.valueOf(foersteTal*andetTal));
        else
          resultatTekstField.setText(String.valueOf((double)(Math.round(foersteTal/andetTal*10000))/10000));
  }
}
